var __assign = this && this.__assign || function () {
  __assign = Object.assign || function (t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
      s = arguments[i];
      for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
    }
    return t;
  };
  return __assign.apply(this, arguments);
};
var __awaiter = this && this.__awaiter || function (thisArg, _arguments, P, generator) {
  function adopt(value) {
    return value instanceof P ? value : new P(function (resolve) {
      resolve(value);
    });
  }
  return new (P || (P = Promise))(function (resolve, reject) {
    function fulfilled(value) {
      try {
        step(generator.next(value));
      } catch (e) {
        reject(e);
      }
    }
    function rejected(value) {
      try {
        step(generator["throw"](value));
      } catch (e) {
        reject(e);
      }
    }
    function step(result) {
      result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected);
    }
    step((generator = generator.apply(thisArg, _arguments || [])).next());
  });
};
var __generator = this && this.__generator || function (thisArg, body) {
  var _ = {
      label: 0,
      sent: function sent() {
        if (t[0] & 1) throw t[1];
        return t[1];
      },
      trys: [],
      ops: []
    },
    f,
    y,
    t,
    g;
  return g = {
    next: verb(0),
    "throw": verb(1),
    "return": verb(2)
  }, typeof Symbol === "function" && (g[Symbol.iterator] = function () {
    return this;
  }), g;
  function verb(n) {
    return function (v) {
      return step([n, v]);
    };
  }
  function step(op) {
    if (f) throw new TypeError("Generator is already executing.");
    while (g && (g = 0, op[0] && (_ = 0)), _) try {
      if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
      if (y = 0, t) op = [op[0] & 2, t.value];
      switch (op[0]) {
        case 0:
        case 1:
          t = op;
          break;
        case 4:
          _.label++;
          return {
            value: op[1],
            done: false
          };
        case 5:
          _.label++;
          y = op[1];
          op = [0];
          continue;
        case 7:
          op = _.ops.pop();
          _.trys.pop();
          continue;
        default:
          if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) {
            _ = 0;
            continue;
          }
          if (op[0] === 3 && (!t || op[1] > t[0] && op[1] < t[3])) {
            _.label = op[1];
            break;
          }
          if (op[0] === 6 && _.label < t[1]) {
            _.label = t[1];
            t = op;
            break;
          }
          if (t && _.label < t[2]) {
            _.label = t[2];
            _.ops.push(op);
            break;
          }
          if (t[2]) _.ops.pop();
          _.trys.pop();
          continue;
      }
      op = body.call(thisArg, _);
    } catch (e) {
      op = [6, e];
      y = 0;
    } finally {
      f = t = 0;
    }
    if (op[0] & 5) throw op[1];
    return {
      value: op[0] ? op[1] : void 0,
      done: true
    };
  }
};
var __rest = this && this.__rest || function (s, e) {
  var t = {};
  for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0) t[p] = s[p];
  if (s != null && typeof Object.getOwnPropertySymbols === "function") for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
    if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i])) t[p[i]] = s[p[i]];
  }
  return t;
};
import React, { useEffect, useState } from 'react';
import { PictureOutlined } from '@ant-design/icons';
import BraftEditor from 'braft-editor';
import { ContentUtils } from 'braft-utils';
import Table from 'braft-extensions/dist/table';
import MaxLength from 'braft-extensions/dist/max-length';
import ColorPicker from 'braft-extensions/dist/color-picker';
import 'braft-editor/dist/index.css';
import 'braft-extensions/dist/table.css';
import 'braft-extensions/dist/color-picker.css';
import 'braft-extensions/dist/code-highlighter.css';
import UploadCustom from '../UploadCustom';
// 表格扩展
BraftEditor.use(Table());
// 输入字数限制扩展
BraftEditor.use(MaxLength({
  defaultValue: 10000
}));
// 高级拾色器扩展
BraftEditor.use(ColorPicker({
  theme: 'light' // 支持dark和light两种主题，默认为dark
}));

function escape2Html(str) {
  var arrEntities = {
    lt: '<',
    gt: '>',
    nbsp: ' ',
    amp: '&',
    quot: '"'
  };
  return str.replace(/&(lt|gt|nbsp|amp|quot);/gi, function (_, t) {
    return arrEntities[t];
  });
}
/**
 * 编辑器控件
 * 文档地址: https://www.yuque.com/braft-editor/be/lzwpnr
 * 编辑器首页: https://braft.margox.cn/
 */
var MyBraftEditor = function MyBraftEditor(_a) {
  var value = _a.value,
    valueType = _a.valueType,
    extendControlKey = _a.extendControlKey,
    uploadProps = _a.uploadProps,
    onChange = _a.onChange,
    restProps = __rest(_a, ["value", "valueType", "extendControlKey", "uploadProps", "onChange"]);
  var _b = useState([]),
    fileList = _b[0],
    setFileList = _b[1];
  var _c = useState(BraftEditor.createEditorState(null)),
    editorState = _c[0],
    setEditorState = _c[1];
  useEffect(function () {
    if (value && editorState.isEmpty()) {
      setEditorState(BraftEditor.createEditorState(escape2Html(value)));
    }
  }, [value]);
  // 编辑器内容改变事件
  var handleChange = function handleChange(state) {
    return __awaiter(void 0, void 0, void 0, function () {
      var content;
      return __generator(this, function (_a) {
        content = valueType === 'raw' ? state.toRAW() : state.toHTML();
        setEditorState(state);
        if (onChange) onChange(content);
        return [2 /*return*/];
      });
    });
  };

  var handleUpload = function handleUpload(fileList) {
    var file = fileList[0];
    setFileList(fileList);
    if ((file === null || file === void 0 ? void 0 : file.status) === 'done') {
      setEditorState(ContentUtils.insertMedias(editorState, [{
        type: 'IMAGE',
        url: file.url
      }]));
      setFileList([]);
    }
  };
  return (
    /*#__PURE__*/
    // @ts-ignore
    React.createElement(BraftEditor, __assign({
      value: editorState,
      onChange: handleChange,
      style: {
        border: '1px solid #d1d1d1',
        borderRadius: 5
      },
      contentStyle: {
        height: 300
      },
      controlBarStyle: {
        backgroundColor: '#f1f1f1'
      },
      controls: ['font-size', 'text-color', 'bold', 'italic', 'underline', 'strike-through', 'text-align', 'emoji', 'text-indent', 'link', 'hr', 'separator', 'media'],
      media: {
        externals: {
          image: true,
          video: false,
          audio: false,
          embed: false
        }
      },
      extendControls: [{
        key: 'antd-uploader',
        type: 'component',
        component: /*#__PURE__*/React.createElement(UploadCustom, __assign({
          filePath: "editor/",
          accept: "image/*",
          listType: "text",
          limit: Number.MAX_SAFE_INTEGER,
          showCropper: false,
          fileList: fileList,
          showUploadList: false,
          onChange: handleUpload
        }, uploadProps), /*#__PURE__*/React.createElement("button", {
          type: "button",
          className: "control-item button upload-button",
          "data-title": "\u63D2\u5165\u56FE\u7247"
        }, /*#__PURE__*/React.createElement(PictureOutlined, null)))
      }]
    }, restProps))
  );
};
MyBraftEditor.defaultProps = {
  valueType: 'html',
  extendControlKey: []
};
export default MyBraftEditor;