import "antd/es/modal/style";
import _Modal from "antd/es/modal";
var __assign = this && this.__assign || function () {
  __assign = Object.assign || function (t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
      s = arguments[i];
      for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
    }
    return t;
  };
  return __assign.apply(this, arguments);
};
var __rest = this && this.__rest || function (s, e) {
  var t = {};
  for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0) t[p] = s[p];
  if (s != null && typeof Object.getOwnPropertySymbols === "function") for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
    if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i])) t[p[i]] = s[p[i]];
  }
  return t;
};
import React, { useRef, useState } from 'react';
import { usePersistFn } from '@delonix/react-hooks';
import { ModalForm } from '@ant-design/pro-form';
import Draggable from 'react-draggable';
export var DraggerModal = function DraggerModal(props) {
  var title = props.title,
    children = props.children,
    otherProps = __rest(props, ["title", "children"]);
  var dragRef = useRef(null);
  var _a = useState(true),
    disabled = _a[0],
    setDisabled = _a[1];
  var _b = useState({
      left: 0,
      top: 0,
      bottom: 0,
      right: 0
    }),
    bounds = _b[0],
    setBounds = _b[1];
  var onStart = usePersistFn(function (event, uiData) {
    var _a;
    var _b = (_a = window === null || window === void 0 ? void 0 : window.document) === null || _a === void 0 ? void 0 : _a.documentElement,
      clientWidth = _b.clientWidth,
      clientHeight = _b.clientHeight;
    var targetRect = dragRef === null || dragRef === void 0 ? void 0 : dragRef.current.getBoundingClientRect();
    setBounds(function () {
      return {
        left: -(targetRect === null || targetRect === void 0 ? void 0 : targetRect.left) + (uiData === null || uiData === void 0 ? void 0 : uiData.x),
        right: clientWidth - ((targetRect === null || targetRect === void 0 ? void 0 : targetRect.right) - (uiData === null || uiData === void 0 ? void 0 : uiData.x)),
        top: -(targetRect === null || targetRect === void 0 ? void 0 : targetRect.top) + (uiData === null || uiData === void 0 ? void 0 : uiData.y),
        bottom: clientHeight - ((targetRect === null || targetRect === void 0 ? void 0 : targetRect.bottom) - (uiData === null || uiData === void 0 ? void 0 : uiData.y))
      };
    });
  });
  return /*#__PURE__*/React.createElement(_Modal, __assign({
    title: /*#__PURE__*/React.createElement("div", {
      style: {
        width: '100%',
        cursor: 'move'
      },
      onMouseOver: function onMouseOver() {
        if (disabled) setDisabled(false);
      },
      onMouseOut: function onMouseOut() {
        return setDisabled(true);
      },
      // fix eslintjsx-a11y/mouse-events-have-key-events
      // https://github.com/jsx-eslint/eslint-plugin-jsx-a11y/blob/master/docs/rules/mouse-events-have-key-events.md
      onFocus: function onFocus() {},
      onBlur: function onBlur() {}
    }, title)
  }, otherProps, {
    modalRender: function modalRender(modal) {
      return (
        /*#__PURE__*/
        // @ts-ignore
        React.createElement(Draggable, {
          disabled: disabled,
          bounds: bounds,
          onStart: onStart
        }, /*#__PURE__*/React.createElement("div", {
          ref: dragRef
        }, modal))
      );
    }
  }), children);
};
export function DraggerModalForm(props) {
  var title = props.title,
    modalProps = props.modalProps,
    children = props.children,
    othersProps = __rest(props, ["title", "modalProps", "children"]);
  var dragRef = useRef(null);
  var _a = useState(true),
    disabled = _a[0],
    setDisabled = _a[1];
  var _b = useState({
      left: 0,
      top: 0,
      bottom: 0,
      right: 0
    }),
    bounds = _b[0],
    setBounds = _b[1];
  var _onStart = usePersistFn(function (event, uiData) {
    var _a;
    var _b = (_a = window === null || window === void 0 ? void 0 : window.document) === null || _a === void 0 ? void 0 : _a.documentElement,
      clientWidth = _b.clientWidth,
      clientHeight = _b.clientHeight;
    var targetRect = dragRef === null || dragRef === void 0 ? void 0 : dragRef.current.getBoundingClientRect();
    setBounds(function () {
      return {
        left: -(targetRect === null || targetRect === void 0 ? void 0 : targetRect.left) + (uiData === null || uiData === void 0 ? void 0 : uiData.x),
        right: clientWidth - ((targetRect === null || targetRect === void 0 ? void 0 : targetRect.right) - (uiData === null || uiData === void 0 ? void 0 : uiData.x)),
        top: -(targetRect === null || targetRect === void 0 ? void 0 : targetRect.top) + (uiData === null || uiData === void 0 ? void 0 : uiData.y),
        bottom: clientHeight - ((targetRect === null || targetRect === void 0 ? void 0 : targetRect.bottom) - (uiData === null || uiData === void 0 ? void 0 : uiData.y))
      };
    });
  });
  return /*#__PURE__*/React.createElement(ModalForm, __assign({
    title: /*#__PURE__*/React.createElement("div", {
      style: {
        width: '100%',
        cursor: 'move'
      },
      onMouseOver: function onMouseOver() {
        if (disabled) setDisabled(false);
      },
      onMouseOut: function onMouseOut() {
        return setDisabled(true);
      },
      // fix eslintjsx-a11y/mouse-events-have-key-events
      // https://github.com/jsx-eslint/eslint-plugin-jsx-a11y/blob/master/docs/rules/mouse-events-have-key-events.md
      onFocus: function onFocus() {},
      onBlur: function onBlur() {}
    }, title)
  }, othersProps, {
    modalProps: __assign(__assign({}, modalProps), {
      modalRender: function modalRender(modal) {
        return (
          /*#__PURE__*/
          // @ts-ignore
          React.createElement(Draggable, {
            disabled: disabled,
            bounds: bounds,
            onStart: function onStart(event, uiData) {
              return _onStart(event, uiData);
            }
          }, /*#__PURE__*/React.createElement("div", {
            ref: dragRef
          }, modal))
        );
      }
    })
  }), children);
}