import "antd/es/input/style";
import _Input from "antd/es/input";
import "antd/es/auto-complete/style";
import _AutoComplete from "antd/es/auto-complete";
var __rest = this && this.__rest || function (s, e) {
  var t = {};
  for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0) t[p] = s[p];
  if (s != null && typeof Object.getOwnPropertySymbols === "function") for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
    if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i])) t[p[i]] = s[p[i]];
  }
  return t;
};
import React, { useRef } from 'react';
import { SearchOutlined } from '@ant-design/icons';
import useMergedState from 'rc-util/es/hooks/useMergedState';
import classNames from 'classnames';
import './index.less';
var prefixCls = 'header-search';
var HeaderSearch = function HeaderSearch(props) {
  var _a;
  var className = props.className,
    defaultValue = props.defaultValue,
    onVisibleChange = props.onVisibleChange,
    placeholder = props.placeholder,
    visible = props.visible,
    defaultVisible = props.defaultVisible,
    restProps = __rest(props, ["className", "defaultValue", "onVisibleChange", "placeholder", "visible", "defaultVisible"]);
  // @ts-ignore
  var inputRef = useRef(null);
  var _b = useMergedState(defaultValue, {
      value: props.value,
      onChange: props.onChange
    }),
    value = _b[0],
    setValue = _b[1];
  var _c = useMergedState(defaultVisible !== null && defaultVisible !== void 0 ? defaultVisible : false, {
      value: props.visible,
      onChange: onVisibleChange
    }),
    searchMode = _c[0],
    setSearchMode = _c[1];
  var inputClass = classNames("".concat(prefixCls, "-input"), (_a = {}, _a["".concat(prefixCls, "-input-show")] = searchMode, _a));
  return /*#__PURE__*/React.createElement("div", {
    className: classNames(className, prefixCls),
    onClick: function onClick() {
      setSearchMode(true);
      if (searchMode && inputRef.current) {
        inputRef.current.focus();
      }
    },
    onTransitionEnd: function onTransitionEnd(_a) {
      var propertyName = _a.propertyName;
      if (propertyName === 'width' && !searchMode) {
        if (onVisibleChange) {
          onVisibleChange(searchMode);
        }
      }
    }
  }, /*#__PURE__*/React.createElement(SearchOutlined, {
    key: "Icon",
    style: {
      cursor: 'pointer'
    }
  }), /*#__PURE__*/React.createElement(_AutoComplete, {
    key: "AutoComplete",
    className: inputClass,
    value: value,
    options: restProps.options,
    // @ts-ignore
    onChange: setValue
  }, /*#__PURE__*/React.createElement(_Input, {
    size: "small",
    ref: inputRef,
    defaultValue: defaultValue,
    "aria-label": placeholder,
    placeholder: placeholder,
    onKeyDown: function onKeyDown(e) {
      if (e.key === 'Enter') {
        if (restProps.onSearch) {
          restProps.onSearch(value);
        }
      }
    },
    onBlur: function onBlur() {
      setSearchMode(false);
    }
  })));
};
export default HeaderSearch;