var __awaiter = this && this.__awaiter || function (thisArg, _arguments, P, generator) {
  function adopt(value) {
    return value instanceof P ? value : new P(function (resolve) {
      resolve(value);
    });
  }
  return new (P || (P = Promise))(function (resolve, reject) {
    function fulfilled(value) {
      try {
        step(generator.next(value));
      } catch (e) {
        reject(e);
      }
    }
    function rejected(value) {
      try {
        step(generator["throw"](value));
      } catch (e) {
        reject(e);
      }
    }
    function step(result) {
      result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected);
    }
    step((generator = generator.apply(thisArg, _arguments || [])).next());
  });
};
var __generator = this && this.__generator || function (thisArg, body) {
  var _ = {
      label: 0,
      sent: function sent() {
        if (t[0] & 1) throw t[1];
        return t[1];
      },
      trys: [],
      ops: []
    },
    f,
    y,
    t,
    g;
  return g = {
    next: verb(0),
    "throw": verb(1),
    "return": verb(2)
  }, typeof Symbol === "function" && (g[Symbol.iterator] = function () {
    return this;
  }), g;
  function verb(n) {
    return function (v) {
      return step([n, v]);
    };
  }
  function step(op) {
    if (f) throw new TypeError("Generator is already executing.");
    while (g && (g = 0, op[0] && (_ = 0)), _) try {
      if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
      if (y = 0, t) op = [op[0] & 2, t.value];
      switch (op[0]) {
        case 0:
        case 1:
          t = op;
          break;
        case 4:
          _.label++;
          return {
            value: op[1],
            done: false
          };
        case 5:
          _.label++;
          y = op[1];
          op = [0];
          continue;
        case 7:
          op = _.ops.pop();
          _.trys.pop();
          continue;
        default:
          if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) {
            _ = 0;
            continue;
          }
          if (op[0] === 3 && (!t || op[1] > t[0] && op[1] < t[3])) {
            _.label = op[1];
            break;
          }
          if (op[0] === 6 && _.label < t[1]) {
            _.label = t[1];
            t = op;
            break;
          }
          if (t && _.label < t[2]) {
            _.label = t[2];
            _.ops.push(op);
            break;
          }
          if (t[2]) _.ops.pop();
          _.trys.pop();
          continue;
      }
      op = body.call(thisArg, _);
    } catch (e) {
      op = [6, e];
      y = 0;
    } finally {
      f = t = 0;
    }
    if (op[0] & 5) throw op[1];
    return {
      value: op[0] ? op[1] : void 0,
      done: true
    };
  }
};
var dataURLtoFile = function dataURLtoFile(dataurl, filename) {
  var arr = dataurl.split(',');
  var mime = arr[0].match(/:(.*?);/);
  var bstr = atob(arr[1]);
  var n = bstr.length;
  var u8arr = new Uint8Array(n);
  while (n--) {
    u8arr[n] = bstr.charCodeAt(n);
  }
  return new File([u8arr], filename, {
    type: mime ? mime[1] : 'jpg'
  });
};
export var compressImg = function compressImg(file) {
  var compressFile;
  var reader = new FileReader();
  reader.readAsDataURL(file);
  var fileSize = +parseFloat(
  // @ts-ignore
  parseInt("".concat(file.size), 10) / 1024 / 1024).toFixed(2);
  return new Promise(function (resolve) {
    reader.onload = function (e) {
      var img = new Image();
      img.src = e.target.result;
      img.onload = function () {
        var base64;
        // 生成canvas
        var canvas = document.createElement('canvas');
        var ctx = canvas.getContext('2d');
        // 默认按比例压缩
        var w = img.width;
        var h = img.height;
        // 创建属性节点
        canvas.setAttribute('width', "".concat(w, "px"));
        canvas.setAttribute('height', "".concat(h, "px"));
        ctx.drawImage(img, 0, 0, w, h);
        if (fileSize < 1) {
          // 如果图片小于一兆 那么压缩0.8
          base64 = canvas.toDataURL(file.type, 0.8);
        } else if (fileSize > 1 && fileSize < 2) {
          // 如果图片大于1M并且小于2M 那么压缩0.5
          base64 = canvas.toDataURL(file.type, 0.5);
        } else {
          // 如果图片超过2m 那么压缩0.2
          base64 = canvas.toDataURL(file.type, 0.2);
        }
        // 回调函数返回file的值（将base64编码转成file）
        compressFile = dataURLtoFile(base64, file.name); // 如果后台接收类型为base64的话这一步可以省略
        resolve(compressFile);
      };
    };
  });
};
export var getImageData = function getImageData(file) {
  return new Promise(function (resolve, reject) {
    var fileReader = new FileReader();
    fileReader.readAsDataURL(file);
    fileReader.onload = function (e) {
      var src = e.target.result;
      var image = new Image();
      image.src = src;
      image.onload = function () {
        // @ts-ignore
        resolve({
          naturalWidth: this.width,
          naturalHeight: this.height,
          src: src
        });
      };
      image.onerror = reject;
    };
  });
};
export var normFile = function normFile(e) {
  console.log('Upload event:', e);
  if (Array.isArray(e)) {
    return e;
  }
  return e && e.fileList;
};
// 图片预览处理
export var handlePreview = function handlePreview(file) {
  return __awaiter(void 0, void 0, void 0, function () {
    var url, originFileObj, type, src, image, imgWindow;
    return __generator(this, function (_a) {
      switch (_a.label) {
        case 0:
          url = file.url, originFileObj = file.originFileObj, type = file.type;
          src = url || '';
          if (!((!src || src.indexOf('http') === -1) && type.indexOf('image') !== -1)) return [3 /*break*/, 2];
          image = new Image();
          return [4 /*yield*/, new Promise(function (resolve) {
            var reader = new FileReader();
            reader.readAsDataURL(originFileObj);
            reader.onload = function () {
              return resolve(reader.result);
            };
          })];
        case 1:
          src = _a.sent();
          image.src = src;
          imgWindow = window.open(src);
          if (image.outerHTML) imgWindow === null || imgWindow === void 0 ? void 0 : imgWindow.document.write(image.outerHTML);
          return [3 /*break*/, 3];
        case 2:
          window.open(src);
          _a.label = 3;
        case 3:
          return [2 /*return*/];
      }
    });
  });
};
// 生成唯一id
export function generateUUID() {
  var d = new Date().getTime();
  var uuid = 'xxxxxxxx-xxxx-4xxx-yxxx-xxxxxxxxxxxx'.replace(/[xy]/g, function (c) {
    var r = (d + Math.random() * 16) % 16 | 0;
    d = Math.floor(d / 16);
    return (c == 'x' ? r : r & 0x3 | 0x8).toString(16);
  });
  return uuid;
}