"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
var _typeof = require("@babel/runtime/helpers/typeof");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.DraggerModal = void 0;
exports.DraggerModalForm = DraggerModalForm;
require("antd/es/modal/style");
var _modal = _interopRequireDefault(require("antd/es/modal"));
var _react = _interopRequireWildcard(require("react"));
var _reactHooks = require("@delonix/react-hooks");
var _proForm = require("@ant-design/pro-form");
var _reactDraggable = _interopRequireDefault(require("react-draggable"));
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
var __assign = void 0 && (void 0).__assign || function () {
  __assign = Object.assign || function (t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
      s = arguments[i];
      for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
    }
    return t;
  };
  return __assign.apply(this, arguments);
};
var __rest = void 0 && (void 0).__rest || function (s, e) {
  var t = {};
  for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0) t[p] = s[p];
  if (s != null && typeof Object.getOwnPropertySymbols === "function") for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
    if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i])) t[p[i]] = s[p[i]];
  }
  return t;
};
var DraggerModal = function DraggerModal(props) {
  var title = props.title,
    children = props.children,
    otherProps = __rest(props, ["title", "children"]);
  var dragRef = (0, _react.useRef)(null);
  var _a = (0, _react.useState)(true),
    disabled = _a[0],
    setDisabled = _a[1];
  var _b = (0, _react.useState)({
      left: 0,
      top: 0,
      bottom: 0,
      right: 0
    }),
    bounds = _b[0],
    setBounds = _b[1];
  var onStart = (0, _reactHooks.usePersistFn)(function (event, uiData) {
    var _a;
    var _b = (_a = window === null || window === void 0 ? void 0 : window.document) === null || _a === void 0 ? void 0 : _a.documentElement,
      clientWidth = _b.clientWidth,
      clientHeight = _b.clientHeight;
    var targetRect = dragRef === null || dragRef === void 0 ? void 0 : dragRef.current.getBoundingClientRect();
    setBounds(function () {
      return {
        left: -(targetRect === null || targetRect === void 0 ? void 0 : targetRect.left) + (uiData === null || uiData === void 0 ? void 0 : uiData.x),
        right: clientWidth - ((targetRect === null || targetRect === void 0 ? void 0 : targetRect.right) - (uiData === null || uiData === void 0 ? void 0 : uiData.x)),
        top: -(targetRect === null || targetRect === void 0 ? void 0 : targetRect.top) + (uiData === null || uiData === void 0 ? void 0 : uiData.y),
        bottom: clientHeight - ((targetRect === null || targetRect === void 0 ? void 0 : targetRect.bottom) - (uiData === null || uiData === void 0 ? void 0 : uiData.y))
      };
    });
  });
  return /*#__PURE__*/_react.default.createElement(_modal.default, __assign({
    title: /*#__PURE__*/_react.default.createElement("div", {
      style: {
        width: '100%',
        cursor: 'move'
      },
      onMouseOver: function onMouseOver() {
        if (disabled) setDisabled(false);
      },
      onMouseOut: function onMouseOut() {
        return setDisabled(true);
      },
      // fix eslintjsx-a11y/mouse-events-have-key-events
      // https://github.com/jsx-eslint/eslint-plugin-jsx-a11y/blob/master/docs/rules/mouse-events-have-key-events.md
      onFocus: function onFocus() {},
      onBlur: function onBlur() {}
    }, title)
  }, otherProps, {
    modalRender: function modalRender(modal) {
      return (
        /*#__PURE__*/
        // @ts-ignore
        _react.default.createElement(_reactDraggable.default, {
          disabled: disabled,
          bounds: bounds,
          onStart: onStart
        }, /*#__PURE__*/_react.default.createElement("div", {
          ref: dragRef
        }, modal))
      );
    }
  }), children);
};
exports.DraggerModal = DraggerModal;
function DraggerModalForm(props) {
  var title = props.title,
    modalProps = props.modalProps,
    children = props.children,
    othersProps = __rest(props, ["title", "modalProps", "children"]);
  var dragRef = (0, _react.useRef)(null);
  var _a = (0, _react.useState)(true),
    disabled = _a[0],
    setDisabled = _a[1];
  var _b = (0, _react.useState)({
      left: 0,
      top: 0,
      bottom: 0,
      right: 0
    }),
    bounds = _b[0],
    setBounds = _b[1];
  var _onStart = (0, _reactHooks.usePersistFn)(function (event, uiData) {
    var _a;
    var _b = (_a = window === null || window === void 0 ? void 0 : window.document) === null || _a === void 0 ? void 0 : _a.documentElement,
      clientWidth = _b.clientWidth,
      clientHeight = _b.clientHeight;
    var targetRect = dragRef === null || dragRef === void 0 ? void 0 : dragRef.current.getBoundingClientRect();
    setBounds(function () {
      return {
        left: -(targetRect === null || targetRect === void 0 ? void 0 : targetRect.left) + (uiData === null || uiData === void 0 ? void 0 : uiData.x),
        right: clientWidth - ((targetRect === null || targetRect === void 0 ? void 0 : targetRect.right) - (uiData === null || uiData === void 0 ? void 0 : uiData.x)),
        top: -(targetRect === null || targetRect === void 0 ? void 0 : targetRect.top) + (uiData === null || uiData === void 0 ? void 0 : uiData.y),
        bottom: clientHeight - ((targetRect === null || targetRect === void 0 ? void 0 : targetRect.bottom) - (uiData === null || uiData === void 0 ? void 0 : uiData.y))
      };
    });
  });
  return /*#__PURE__*/_react.default.createElement(_proForm.ModalForm, __assign({
    title: /*#__PURE__*/_react.default.createElement("div", {
      style: {
        width: '100%',
        cursor: 'move'
      },
      onMouseOver: function onMouseOver() {
        if (disabled) setDisabled(false);
      },
      onMouseOut: function onMouseOut() {
        return setDisabled(true);
      },
      // fix eslintjsx-a11y/mouse-events-have-key-events
      // https://github.com/jsx-eslint/eslint-plugin-jsx-a11y/blob/master/docs/rules/mouse-events-have-key-events.md
      onFocus: function onFocus() {},
      onBlur: function onBlur() {}
    }, title)
  }, othersProps, {
    modalProps: __assign(__assign({}, modalProps), {
      modalRender: function modalRender(modal) {
        return (
          /*#__PURE__*/
          // @ts-ignore
          _react.default.createElement(_reactDraggable.default, {
            disabled: disabled,
            bounds: bounds,
            onStart: function onStart(event, uiData) {
              return _onStart(event, uiData);
            }
          }, /*#__PURE__*/_react.default.createElement("div", {
            ref: dragRef
          }, modal))
        );
      }
    })
  }), children);
}