"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
var _typeof = require("@babel/runtime/helpers/typeof");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
require("antd/es/input/style");
var _input = _interopRequireDefault(require("antd/es/input"));
require("antd/es/auto-complete/style");
var _autoComplete = _interopRequireDefault(require("antd/es/auto-complete"));
var _react = _interopRequireWildcard(require("react"));
var _icons = require("@ant-design/icons");
var _useMergedState = _interopRequireDefault(require("rc-util/es/hooks/useMergedState"));
var _classnames = _interopRequireDefault(require("classnames"));
require("./index.less");
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
var __rest = void 0 && (void 0).__rest || function (s, e) {
  var t = {};
  for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0) t[p] = s[p];
  if (s != null && typeof Object.getOwnPropertySymbols === "function") for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
    if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i])) t[p[i]] = s[p[i]];
  }
  return t;
};
var prefixCls = 'header-search';
var HeaderSearch = function HeaderSearch(props) {
  var _a;
  var className = props.className,
    defaultValue = props.defaultValue,
    onVisibleChange = props.onVisibleChange,
    placeholder = props.placeholder,
    visible = props.visible,
    defaultVisible = props.defaultVisible,
    restProps = __rest(props, ["className", "defaultValue", "onVisibleChange", "placeholder", "visible", "defaultVisible"]);
  // @ts-ignore
  var inputRef = (0, _react.useRef)(null);
  var _b = (0, _useMergedState.default)(defaultValue, {
      value: props.value,
      onChange: props.onChange
    }),
    value = _b[0],
    setValue = _b[1];
  var _c = (0, _useMergedState.default)(defaultVisible !== null && defaultVisible !== void 0 ? defaultVisible : false, {
      value: props.visible,
      onChange: onVisibleChange
    }),
    searchMode = _c[0],
    setSearchMode = _c[1];
  var inputClass = (0, _classnames.default)("".concat(prefixCls, "-input"), (_a = {}, _a["".concat(prefixCls, "-input-show")] = searchMode, _a));
  return /*#__PURE__*/_react.default.createElement("div", {
    className: (0, _classnames.default)(className, prefixCls),
    onClick: function onClick() {
      setSearchMode(true);
      if (searchMode && inputRef.current) {
        inputRef.current.focus();
      }
    },
    onTransitionEnd: function onTransitionEnd(_a) {
      var propertyName = _a.propertyName;
      if (propertyName === 'width' && !searchMode) {
        if (onVisibleChange) {
          onVisibleChange(searchMode);
        }
      }
    }
  }, /*#__PURE__*/_react.default.createElement(_icons.SearchOutlined, {
    key: "Icon",
    style: {
      cursor: 'pointer'
    }
  }), /*#__PURE__*/_react.default.createElement(_autoComplete.default, {
    key: "AutoComplete",
    className: inputClass,
    value: value,
    options: restProps.options,
    // @ts-ignore
    onChange: setValue
  }, /*#__PURE__*/_react.default.createElement(_input.default, {
    size: "small",
    ref: inputRef,
    defaultValue: defaultValue,
    "aria-label": placeholder,
    placeholder: placeholder,
    onKeyDown: function onKeyDown(e) {
      if (e.key === 'Enter') {
        if (restProps.onSearch) {
          restProps.onSearch(value);
        }
      }
    },
    onBlur: function onBlur() {
      setSearchMode(false);
    }
  })));
};
var _default = HeaderSearch;
exports.default = _default;